uniform float angle_radians;
uniform float power;
uniform sampler2D clouds;
uniform float radius;
uniform float one_over_radius;
uniform float fade;
uniform float fadeDistInv;

varying vec2 TexCoord;
const vec2 center = vec2(0.5, 0.5);

//void main (void)
//{
//	gl_FragColor = texture2D(clouds, TexCoord);
//}

void main (void)
{
    vec2 result;
    float d;
    float id;
    float a;
	vec2 curPos = TexCoord;
	
    d = distance(curPos, center);
    id = pow((radius - d) * one_over_radius, power);
    
	vec2 dPos = curPos - center;
	a = atan(dPos.y/dPos.x) + (angle_radians * id * (radius - d) * one_over_radius);
	
	if (d < radius)
	{
		vec2 cos_sin_a;
		float cos_a = cos(a);
		float sin_a = sin(a);
		cos_sin_a.x = cos_a;
		cos_sin_a.y = sin_a;

		result = center + d * sign(dPos.x) * cos_sin_a;
	}
	else
		result = curPos;
	
	vec4 colorMod = texture2D(clouds, result);
	
	if (d > 0.5)
		gl_FragColor = vec4(colorMod.rgb, 0.0);
	else if (d <= fade)
		gl_FragColor = colorMod;
	else
		//gl_FragColor = vec4(colorMod.rgb, colorMod.a * (1.0 - (fadeDistInv * (d - fade))));
		gl_FragColor = colorMod * (1.0 - (fadeDistInv * (d - fade)));
}

